/*
  Global.java

  Global constants

  (P)2002  Dana Cristofor

*/

/*

GAClust - Clustering categorical databases using genetic algorithms
Copyright (C) 2002  Dana Cristofor


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
USA

GAClust was written by Dana Cristofor (dana@cs.umb.edu).

*/

/**
 * Global
 *
 * @version 	1.0
 * @author	Dana Cristofor
 */
public class Global
{
  static final int DEBUG          = 0;
  static final int VERBOSE        = 0;
  static final int ULTRA_VERBOSE  = 0;
  
  static final int FM_PA_P        = 1; // SUM H(piA|pi)
  
  static final int FM_P_PA        = 2; // SUM H(pi|piA)
  
  static final int FM_BOTH        = 3; // SUM [H(piA|pi) + H(pi|piA)]
  
  // SUM [H(piA|pi)/(1+H(piA)) + H(pi|piA)/(1 + H(pi))]
  static final int FM_BOTH_SCALED = 4; 
  
  // SUM [(H(pi) - H(pi|piA)) / (1 + H(piA))]
  static final int FM_Q           = 5;
  
  // SUM [(H(pi) - H(pi|piA)) / (1 + H(pi^piA))]
  static final int FM_L           = 6;

  // SUM [(H(piA) - H(piA|pi)) / (1 + H(pi))]
  static final int FM_QR          = 7;
  
  // SUM [(H(piA) - H(piA|pi)) / (1 + H(pi^piA))]
  static final int FM_LR          = 8;
  
  static final int FM_Q_QR        = 9; // Q + QR
  
  // alternate K, L minimization based on Havg
  static final int FM_ALTERNATE_HAVG = 10;
  
  // alternate K, L minimization based on K, L
  static final int FM_ALTERNATE      = 11;

  static final int FM_MOD            = 12; // min |K + L| + |K - L|
  
  // SUM D(pi, piA)*D(pi*|piA*)/(sqrt(D(pi, piA)^2)*sqrt(D(pi*, piA*)^2))
  static final int FM_COS            = 13;
  
  // SUM D(pi, piA) - (D(pi*|piA*)/ SUM D(pi*, piA*)) * SUM D(pi, piA) 
  static final int FM_NORM_W         = 14;
  
  // exclusion of attributes based on estimated weights 
  static final int FM_WE             = 15;
  
  static final int FM_TEST           = 16; // prototype
}
