/*
  Strings.java

  (P) 2002 Dana Cristofor
*/

/*

GAClust - Clustering categorical databases using genetic algorithms
Copyright (C) 2002  Dana Cristofor


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
USA

GAClust was written by Dana Cristofor (dana@cs.umb.edu).

*/

/**
 * GAClust GUI strings
 *
 * @version 	1.0
 * @author	Dana Cristofor
 */
public class Strings
{
  // program info
  public static final String TITLE = "GAClust";
  public static final String VERSION   = "v1.0";
  public static final String COPYRIGHT = "(C)2002 Dana Cristofor";
  public static final String DESCRIPT  = "An application for clustering databases with categorical attributes.";
  public static final String DISTRIB   = " is distributed under the GNU General Public License.\nSee file 0LICENSE.TXT for more details on licensing terms.";
  public static final String URL       = "url: http://www.cs.umb.edu/~dana/GAClust/";
  public static final String EMAIL     = "email: dana@cs.umb.edu";

  // subdirectories
  public static final String HELP_DIR = "help";

  public static final String UNXP_ERROR = "\n*** An unexpected error occurred in ";
  static public final String ERROR = "\n*** An error occurred in ";

  // miscellaneous
  static public final String PROGRAM = "Program";
  static public final String HELP = "Help";
  static public final String TOPICS = "Topics";
  static public final String ABOUT = "About";
  static public final String FORCEGC = "Force garbage collection";
  static public final String GCSTART = "Starting garbage collection";
  static public final String GCEND = "Garbage collection done";
  static public final String EXIT = "Exit";

  static public final String dots = "...";
  static public final String endl = "\n";
  static public final String space = " ";
  static public final String DBINTRO = 
    "Select a database by typing its name or by using the browse button!\n";
  static public final String DBBORDERTITLE = "Select an existing database";
  static public final String GABORDERTITLE = "Select GA parameters";
  static public final String GENDBBORDERTITLE = 
    "Generate a synthetic database";
  static public final String NROWSERRMSG = 
    "Specify an integer for the number of rows!";
  static public final String NROWSPOSITIVE = 
    "Number of rows must be > 0!";
  static public final String NROWSMORETHAN2 = 
    "Number of attributes must be >= 2!";
  static public final String NATTRERRMSG = 
    "Specify an integer for the number of attributes!";
  static public final String NATTRPOSITIVE = 
    "Number of attributes must be > 0!";
  static public final String POPSIZEERRMSG = 
    "Specify an integer for the population size!";
  static public final String POPSIZEPOSITIVE = 
    "Population size must be > 0!";
  static public final String KERRMSG = 
    "Specify an integer for the number of classes!";
  static public final String KMORETHAN2 = 
    "Number of classes must be >= 2!";
  static public final String CROSSRATEERRMSG = 
    "Specify a double between (0:1) for the crossover rate!";
  static public final String CROSSRATEINTERVAL = 
    "Crossover rate must in (0: 1)!";
  static public final String MUTRATEERRMSG = 
    "Specify a double between (0:1) for the mutation rate!";
  static public final String MUTRATEINTERVAL = 
    "Mutation rate must in (0: 1)!";
  static public final String CROSSMUTSUM = 
    "The sum of mutation and crossover rates must be less than 1!";
  static public final String ADJUSTCROSS = 
    "Specify a different crossover rate!";
  static public final String ADJUSTMUT = 
    "Specify a different mutation rate!";
  static public final String FTHRESERRMSG = 
    "Specify a double for the fitness threshold!";
  static public final String FTHRESPOSITIVE = 
    "Fitness threshold must be > 0!";
  static public final String CITRSERRMSG = 
    "Specify an integer for the number of consecutive iterations!";
  static public final String CITRSPOSITIVE = 
    "Consecutive iterations without improvement must be > 0!";
  static public final String RANDSEEDERRMSG = 
    "Specify an integer for the random seed!";
  static public final String RANDSEEDPOSITIVE = 
    "Random seed must be >= 0!";
  static public final String TIDERRMSG = 
    "Specify an integer for the target id!";
  static public final String TIDPOSITIVE = 
    "Target id must be > 0!";
  static public final String SPCTERRMSG = 
    "Specify a double between (0:1] for the sample database percent!";
  static public final String SPCTINTERVAL = 
    "Percent use to sampling must be in (0, 1]!";
  static public final String NRATTRERRMSG = 
    "Specify an integer for the number of remaining attributes!";
  static public final String NRATTRPOSITIVE = 
    "Number of remaining attributes must be > 0!";

  static public final String WSPCTNEEDED = 
    "For this type of fitness measure you must select to use weights and specify a percent";
  
  static public final String TARGETNEEDED = 
    "For this type of fitness measure you must select to use a target and specify a target";

  static public final String EXCLATTRNEEDED = 
    "For this type of fitness measure you must select to exclude attributes and specify the number of remaining attributes";
  
  static public final String MAXNEEDED = "This type of fitness measure needs to be maximized";

  static public final String MINNEEDED = "This type of fitness measure needs to be minimized";

  static public final String KDBMORETHAN2 = 
    "Number of classes must be >= 2!";

  static public final String CLUSTCLASSCARD = 
    "Clustering classes (their cardinalities)";
  static public final String REFCLASSCARD = 
    "Reference classes (their cardinalities)";
  static public final String DISTRNEEDED = 
    "For this crossover type you must specify a distribution type";

  static public final String DBINVALID = "Invalid database name"; 
  static public final String DBGENERATING = 
    "Generating the database";


  static public final String CF_SYM_DIFF = "Symmetrical difference";
  static public final String CF_PROD = "Product";
  static public final String CF_DIV = "Division";
  static public final String CF_POW = "Power";

  static public final String CROSS_RAND = "Random";
  static public final String CROSS_X_2RAND_CLASS = "X random class";
  static public final String CROSS_AM_X_BEST_CLASS = "X best class";
  static public final String CROSS_AM_X_BEST_WORST = "X best worst class";
  static public final String CROSS_AM_X_2RAND_CLASS = "X random class (LR)";

  static public final String MUT_RAND = "Random";
  static public final String MUT_MOVE_ELEM = "Move elements";
  static public final String MUT_SWAP_ELEM = "Swap elements";

  static public final String DISTRIB_NONE    = "No distribution";
  static public final String DISTRIB_RAND    = "Random";
  static public final String DISTRIB_TO_EVEN = "Distribute to even";  

  static public final String GINI = "Gini";
  static public final String ENTROPY = "Entropy";
  static public final String PEAK = "Peak";
  static public final String CIRCLE = "Circle";
  static public final String SINE = "Sine";
  static public final String SQ = "Sq";
  static public final String GE = "Ge";

  static public final String FM_PA_P = "H(attribute|clustering)"; // SUM H(piA|pi)
  static public  final String FM_P_PA = "H(clustering|attribute)"; // SUM H(pi|piA)
  static public  final String FM_BOTH = "Both"; // SUM [H(piA|pi) + H(pi|piA)]
  // SUM [H(piA|pi)/(1+H(piA)) + H(pi|piA)/(1 + H(pi))]
  static public final String FM_BOTH_SCALED = "Both scaled"; 
  // SUM [(H(pi) - H(pi|piA)) / (1 + H(piA))]
  static public final String FM_Q = "Q";
  // SUM [(H(pi) - H(pi|piA)) / (1 + H(pi^piA))]
  static public final String FM_L = "L";
  // SUM [(H(piA) - H(piA|pi)) / (1 + H(pi))]
  static public final String FM_QR = "QR";
  // SUM [(H(piA) - H(piA|pi)) / (1 + H(pi^piA))]
  static public final String FM_LR  = "LR";
  static public final String FM_Q_QR = "Q+QR"; // Q + QR
  // alternate K, L minimization based on Havg
  static public final String FM_ALTERNATE_HAVG = "Alternate Havg";
  // alternate K, L minimization based on K, L
  static public final String FM_ALTERNATE = "Alternate";
  static public final String FM_MOD  = "Module"; // min |K + L| + |K - L|
  // SUM D(pi, piA)*D(pi*|piA*)/(sqrt(D(pi, piA)^2)*sqrt(D(pi*, piA*)^2))
  static public final String FM_COS  = "Cos";
  // SUM D(pi, piA) - (D(pi*|piA*)/ SUM D(pi*, piA*)) * SUM D(pi, piA) 
  static public final String FM_NORM_W = "Normalizing weights";
  // exclusion of attributes based on estimated weights 
  static public final String FM_WE = "Exclude attributes";
  static public final String FM_TEST = "Test"; // prototype

  static public final String FO_MIN = "Minimization"; // optimization type
  static public final String FO_MAX = "Maximization";

  public static final String CLOSE         = "Close"; 
  static public final String ABOUT_TEXT  = TITLE + space + VERSION + endl
    + COPYRIGHT + endl + endl + DESCRIPT + endl + endl 
    + TITLE + DISTRIB + endl + endl 
    + URL + endl + EMAIL + endl;

  // help files
  public static final String INTRO_HTML      = "intro.html";
  public static final String DEFS_HTML       = "entrdefs.html";
  public static final String REFERENCE_HTML  = "reference.html";
  // public static final String OVERVIEW_HTML   = "overview.html";
  public static final String USER_GUIDE_HTML = "userguide.html";
  // public static final String MISC_INFO_HTML  = "miscinfo.html";


  // help titles
  public static final String INTRO_TITLE      = "Introduction to Clustering using genetic algorithms";
  public static final String DEFS_TITLE       = "Definitions";
  public static final String REFERENCE_TITLE  = "References";
  public static final String MANUAL_TITLE     = "GAClust Manual";
  //public static final String OVERVIEW_TITLE   = "Overview of GAClust";
  public static final String USER_GUIDE_TITLE = "GAClust User's Guide";
  // public static final String MISC_INFO_TITLE  = "GAClust Miscellaneous Information";


  // tool tips
  public static final String DBNAME_TIP = "Enter the database name";
  public static final String BROWSE_TIP = "Browse the directories for a database";
  public static final String NROWS_TIP = "Enter the number of rows";
  public static final String NATTR_TIP = "Enter the number of attributes";
  public static final String OPENDB_TIP = "Open the selected database";
  public static final String GENDBNAME_TIP = "Enter a name for the generated database";
  public static final String USEDEFNAME_TIP = "Use a default name for the generated database";
  public static final String NCLASSES_TIP = "Enter the number of classes";
  public static final String RANDSEED_TIP = "Enter the seed for the random number generator";
  public static final String GENLARGE_TIP = "Generate attribute partitions having a class with more elements than the rest of the classes";
  public static final String GEN_TIP = "Generate the database";
  public static final String GENABORT_TIP = "Stops the generation of the database";
  public static final String POPSIZE_TIP = "Enter the number of chromosomes";
  public static final String CROSSTYPE_TIP = "Select the type of crossover";
  public static final String MUTTYPE_TIP = "Select the type of mutation";
  public static final String CROSSRATE_TIP = "Enter the crossover rate";
  public static final String DISTRTYPE_TIP = "Select the type of distributing the elements in some crossover methods";
  public static final String MUTRATE_TIP = "Enter the mutation rate";
  public static final String CLASSFITNESSTYPE_TIP = "Select the class fitness measure";
  public static final String FTHRES_TIP = "Enter the fitness threshold";
  public static final String ENTROPY_TIP = "Select the entropy measure";
  public static final String CITRS_TIP = "Enter the number of consecutive iterations without improvement after which the clustering will stop";
  public static final String FM_TIP = "Select the fitness measure";
  public static final String OPT_TIP = "Select the optimization type";
  public static final String USETARGET_TIP = "Use this when a target(reference) partition is available";
  public static final String TARGETID_TIP = "Enter the index of the target(reference) partition";
  public static final String USEWEIGHTS_TIP = "Use this for the crossover methods that estimates weights for attributes";
  public static final String SAMPLEDBPCT_TIP = "Enter the percent of the database used for sampling";
  public static final String EXCLUDEATTR_TIP = "Use this for excluding the non-significant attributes";
  public static final String NREMATTR_TIP = "Enter the number of remaining attributes";
  public static final String CLUSTER_TIP = "Cluster the database";
  public static final String CLUSTERABORT_TIP = "Stops the clustering of the database";
  public static final String CLOSE_TIP = "Close dialog";
}
